<?php
/**
 * Copyright © Cloud Linux GmbH & Cloud Linux Software, Inc 2010-2019 All Rights Reserved
 *
 * Licensed under CLOUD LINUX LICENSE AGREEMENT
 * http://cloudlinux.com/docs/LICENSE.TXT
 */


namespace App\Base;

/**
 * Class Component
 *
 * @package selector\base
 * @author: Ruslan Rakhmanberdiev
 */
class Component {

    /**
     * Array of loaded objects
     *
     * @var array
     */
    static protected $_models = array();

    /**
     * @param string $className
     * @return mixed
     */
    public static function load($className = __CLASS__)
    {
        if(isset(self::$_models[$className])) {
            return self::$_models[$className];
        } else {
            self::$_models[$className] = new $className;
            return self::$_models[$className];
        }
    }
} 
