<?php
/**
 * Copyright © Cloud Linux GmbH & Cloud Linux Software, Inc 2010-2019 All Rights Reserved
 *
 * Licensed under CLOUD LINUX LICENSE AGREEMENT
 * http://cloudlinux.com/docs/LICENSE.TXT
 */


namespace App\Base;


/**
 * Implements a throwable container of site user actions errors.
 */
class Exception extends \Exception
{
    /**
     * Contains any data that is related to thrown error.
     *
     * @var array
     */
    public $data;


    /**
     * Creates new throwable container.
     *
     * @param string $message
     * @param array $data
     */
    public function __construct($message, $data = array())
    {
        parent::__construct($message);
        $this->data = $data;
    }
}
