<?php
/**
 * Copyright © Cloud Linux GmbH & Cloud Linux Software, Inc 2010-2019 All Rights Reserved
 *
 * Licensed under CLOUD LINUX LICENSE AGREEMENT
 * http://cloudlinux.com/docs/LICENSE.TXT
 */


namespace App\Base;


/**
 * Class SpaAssets
 *
 * Spa own asset manager
 *
 * @package selector\base
 */
class SpaAssets extends Assets {

    /**
     * @param bool $output
     * @return string
     */
    public function renderScriptFiles($output = true)
    {
        $html = '';

        foreach($this->_scripts as $fileName) {
            $html .= '<script>'.$this->getScriptFileContent($fileName).'</script>';
        }

        if($output) {
            echo $html;
        }

        return $html;
    }

    /**
     * @param bool $output
     * @return string
     */
    public function renderStyleFiles($output = true)
    {
        $html = '';

        foreach($this->_styles as $fileName) {
            $html .= '<style>'.$this->getStyleFileContent($fileName).'</style>';
        }

        if($output) {
            echo $html;
        }

        return $html;
    }
}
