<?php
/**
 * Copyright © Cloud Linux GmbH & Cloud Linux Software, Inc 2010-2019 All Rights Reserved
 *
 * Licensed under CLOUD LINUX LICENSE AGREEMENT
 * http://cloudlinux.com/docs/LICENSE.TXT
 */


namespace App\Controller\Spa;

use App\Base\Base;
use App\Base\Controllers;


class IndexController extends Controllers\Spa
{
    const DEFAULT_LANGUAGE = 'en';

    public function init()
    {
        if(!isset($_ENV['LANGUAGE'])) {
            $_ENV['LANGUAGE'] = DEFAULT_LANGUAGE;
        }

        parent::init();
    }

    public function indexAction()
    {
        if($_SERVER['REQUEST_METHOD'] != 'GET') {
            echo "HTTP/1.1 405 Method Not Allowed\n\n";
            echo "Method Not Allowed";
            return;
        }
        $base = Base::load();
        // $indexFile is .php file name from /usr/local/directadmin/plugins/lvemanager_spa/app/View/Spa/index/
        $indexFile = defined("INDEX_FILE") ? constant("INDEX_FILE") : "index";
        $this->render($indexFile, array(
            'pluginVersion' => $base->billingManager->getPluginVersion(),
            'appMode' => $base->getAppMode(),
            'owner' => $base->getOwner(),
            'userName' => $this->getLogin(),
            'userDomain' => $this->getUserDomain(),
            'useBundle' => defined("USE_BUNDLE") ? constant("USE_BUNDLE") : "main",
            'pluginName' => defined("PLUGIN_NAME") ? constant("PLUGIN_NAME") : "lvemanager_spa",
            'currentLanguage' => $_ENV['LANGUAGE']
        ));
    }

    public function cookieAction()
    {
        echo "HTTP/1.1 200 OK\n";
        if (!isset($_COOKIE['csrftoken'])) {
            $csrftoken = md5(uniqid(rand(), true));
            echo "Set-Cookie: csrftoken=$csrftoken\n";
        }
        echo "Content-type: application/json\n\n";
    }

} 
