<?php
/**
 * Copyright © Cloud Linux GmbH & Cloud Linux Software, Inc 2010-2019 All Rights Reserved
 *
 * Licensed under CLOUD LINUX LICENSE AGREEMENT
 * http://cloudlinux.com/docs/LICENSE.TXT
 */

if(!defined('TEST_CASE')) 
    define('TEST_CASE', false);

/* MAIN Loader */
if(!TEST_CASE){
    require_once('modules/pm.php'); 
    require_once('modules/plesk-lvemanager/config.php');
    require_once('modules/plesk-lvemanager/protect.php');
}

function autoloadClass($className) {
    $classesMap = array(
        'HomePage'          => 'modules/plesk-lvemanager/home.php',
        'DefaultPage'       => 'modules/plesk-lvemanager/default.php',
        'PackagesPage'      => 'modules/plesk-lvemanager/packages.php',
        'PackagesEditPage'  => 'modules/plesk-lvemanager/packagesedit.php',
        'AccountPage'       => 'modules/plesk-lvemanager/accounts.php',
        'StatsPage'         => 'modules/plesk-lvemanager/stats.php',
        'EditPage'          => 'modules/plesk-lvemanager/edit.php',
        'HistoryPage'       => 'modules/plesk-lvemanager/history.php',
    );
    
    if(array_key_exists($className, $classesMap))
        $filename = $classesMap[$className];
    else
        $filename = "modules/plesk-lvemanager/" . $className . ".php";

    if(stream_resolve_include_path($filename) !== FALSE)
        require_once($filename);
}

spl_autoload_register('autoloadClass');