<?php
/**
 * Copyright © Cloud Linux GmbH & Cloud Linux Software, Inc 2010-2019 All Rights Reserved
 *
 * Licensed under CLOUD LINUX LICENSE AGREEMENT
 * http://cloudlinux.com/docs/LICENSE.TXT
 */

use Modules_PleskLvemanager_CheckData as CheckData;
use Modules_PleskLvemanager_Controllers_Spa as Spa;

abstract class UserController extends Modules_PleskLvemanager_Controllers_User
{
    const DEFAULT_LANGUAGE = 'en-US';

    public function indexAction()
    {
        $this->userType = Spa::OWNER_USER;

        if ($_SERVER['REQUEST_METHOD'] != 'GET') {
            $this->sendErrorResponse('Method Not Allowed', $statusCode = 405);
        }

        // Rendering of main template.
        if (!isset($_COOKIE['csrftoken'])) {
            setcookie("csrftoken", md5(uniqid(rand(), true)), time() + 86400, '/', '', true);
        }

        $this->view->pleskVersion = str_replace(
            '.', '',
            number_format((float)CheckData::getPleskVersion(), 1)
        );

        $this->view->pluginVersion = CheckData::getPluginVersion();
        $this->view->owner = Spa::OWNER_USER;
        $this->view->userName = $this->getLogin();
        $this->view->appMode = CheckData::getAppMode();
        $currentLanguage = pm_Locale::getCode();
        $this->view->currentLanguage = $currentLanguage;
    }
}