<?php
/**
 * Copyright © Cloud Linux GmbH & Cloud Linux Software, Inc 2010-2019 All Rights Reserved
 *
 * Licensed under CLOUD LINUX LICENSE AGREEMENT
 * http://cloudlinux.com/docs/LICENSE.TXT
 */


class SendRequestController extends Modules_PleskLvemanager_Controllers_Spa
{
    /**
     * @throws pm_Exception
     */
    public function indexAction()
    {
        if($_SERVER['REQUEST_METHOD'] != 'POST') {
            $this->sendErrorResponse('Method Not Allowed', $statusCode=405);
        }

        $this->_helper->layout->disableLayout();
        $this->_helper->viewRenderer->setNoRender(true);

        if ($this->client->isAdmin()) {
            $userType = self::OWNER_ADMIN;
        } else if($this->client->isReseller()) {
            $userType = self::OWNER_RESELLER;
        } else {
            $userType = self::OWNER_USER;
        }
        $this->processRequest($userType);
    }
}
